#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "book.h"
book library[MAX_BOOKS];
user user_list[MAX_USERS];

char * trim_fgets(char *s, size_t size, FILE * stream){
	int len;
	fgets(s, size, stream);
	len = strlen(s);
	if(s[len-1] == '\n') s[len-1] = '\0';
	return s;
}

int main(){
	FILE *fp;
	int wait, book_count, return_value;
	int user_id, index, i, j, books, users;
	char title[MAX_TITLE_LENGTH], category[NAME_MAX], condition[NAME_MAX], name[NAME_MAX], type[NAME_MAX], order[NAME_MAX];
	char *order_list[10]={"import", "register_book", "register_user", "index_book","index_user", "query", "borrow", "return", "print", "end"};
	book **query_result;
	book *lib_addr[100];
	initialize();

	for(i = 0;i < MAX_BOOKS;i++) lib_addr[i] = &library[i];


	while(1){
	scanf("%s", order);
	getchar();
	for(i = 0;i < 10;i++){
		if(!strcmp(order, order_list[i])) break;
	}
	i++;
	printf("* order : %s *\n", order);
	switch(i){
		case 1: //Import
			fp = fopen("./library.txt", "r");
			if(!fp) printf("No data to import\n");
			else{
				fscanf(fp, "%d %d", &books, &users);
				fgetc(fp);
				for(j=0;j<books;j++){
					trim_fgets(title, sizeof(title), fp); 
					trim_fgets(type, sizeof(type), fp);
					register_book(title, type);		
				}
				for(j=0;j<users;j++){
					trim_fgets(name, sizeof(name), fp);
					register_user(name);		
				}
				fclose(fp);
			}

			break; 	
		case 2: //Register_book
			trim_fgets(title, sizeof(title), stdin);
			trim_fgets(type, sizeof(type), stdin);
			register_book(title, type);		
			books++;
			break;
		case 3: //Register_user
			trim_fgets(name, sizeof(name), stdin);
			register_user(name);
			users++;
			break;
		case 4: //Index_book
			trim_fgets(title, sizeof(title), stdin);
			printf("Index %d: %s\n", index_book(title), title);
			break;
		case 5: //Index_user
			trim_fgets(name, sizeof(name), stdin);		
			printf("Index %d: %s\n", index_user(name), name);
			break;
		case 6: //Query
			trim_fgets(category, sizeof(category), stdin);
			trim_fgets(condition, sizeof(condition), stdin);
			book_count = query_book(category, condition, &query_result);	
			print_books(query_result, category, 0, book_count);
			free(query_result);
			break;
		case 7: //Borrow
			trim_fgets(title, sizeof(title), stdin);
			trim_fgets(name, sizeof(name), stdin);
			scanf("%d", &wait);
			getchar();
			index = index_book(title);
			if(index == -1) {printf("Book not found.\n"); break;}
			user_id = index_user(name);	
			if(user_id == -1) {printf("You should register first!\n"); break;}
			return_value = borrow_book(index, user_id, wait);
			if(return_value == -1) printf("Limit exceeded.\n");
			else if(return_value == -2) printf("Too many waiters.\n");
			else if(return_value == -3) printf("Failed to borrow the book.\n");
			break;
		case 8: //Return
			trim_fgets(title, sizeof(title), stdin);
			index = index_book(title);
			return_book(index);
			break;
		case 9: //Print_whole_books
			trim_fgets(category, sizeof(category),stdin);
			scanf("%d",  &wait);
			getchar();
			print_books(lib_addr, category, wait, books);
			break;
		case 10:
			return 0;
		default:
		printf("Wrong Command\n");
		break;
	}
	}
}
